###############################################################################
# Preview.pl                                                                  #
###############################################################################
#                                                                             #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
#                                                                             #
# Version:        YaBB 1 Gold - SP 1.3.2                                      #
# Released:       December 2001; Updated August 17, 2004                      #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2004 YaBB (www.yabbforum.com) - All Rights Reserved.     #
#                                                                             #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
# =========================================================================== #
# Mod Name:    TPB-PPB 1.0 for YaBB  Gold - SP1.3.1-1.3.2                     #
# Written by:  JannoL - webmaster@jannol.com                                  #
###############################################################################

$previewplmodver = "1.0 for 1 Gold - SP 1.3.1-1.3.2";

sub PreviewTopic {
	$dispprev = "";  # clear output before current Board Topic Preview
	local($curboard) = @_;
	my $maxindex = $numberpreviewsubjects;
	
	# Make sure the starting place makes sense.
	if( $start > $threadcount ) { $start = int( $threadcount % $maxindex ) * $maxindex; }
	elsif( $start < 0 ) { $start = 0; }
		
	# Open and quickly read the current board thread list.
	# Skip past threads until we reach the "page" we want.
	fopen(FILE, "$boardsdir/$curboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $curboard.txt");
	@threadlist = <FILE>;
	$threadcount = $#threadlist;
	@threadlist2 = '';
	fclose(FILE);
	
	# Sticky Threads
	@stickylist = ''; # First empty stickylist for a fresh start for every Board, THX to Pages from Sages
	fopen(FILE, "$boardsdir/sticky.stk") || &fatal_error("300 $txt{'106'}: $txt{'23'} sticky.stk");
	@stickys = <FILE>;
	$stickycount = $#stickys;
	fclose(FILE);
	
	for ($i=0; $i<=$threadcount; $i++) {
		($mnum,$prevsub,$prevgroup,$prevmail,$prevdate) = split( /\|/, $threadlist[$i] );
		$l = 0;
		$is = 0;
		foreach $curnum (@stickys) {
			if ($curnum == $mnum) {
				$is = 1;
				# Only include stickies if it has new posts
				$dlp = &getlog($mnum);
				$threaddate = stringtotime($prevdate);
				if( $max_log_days_old && $dlp < $threaddate && &getlog("$curboard--mark") < $threaddate ) {
				$stickylist[$l] = $threadlist[$i];
				}
				last;
			}
			$l++;
		}
	if ($is == 0) { push(@threadlist2,$threadlist[$i]); }
	}
	if (!($threadlist2[0])) { shift(@threadlist2); }
		
	#now sort the stickys
	@stickylist2 = sort {$b <=> $a } keys %stickylist;
	for ($i=0; $i<=$stickycount; $i++) {
		chomp $stickylist[$i];
		if ($stickylist[$i]) { unshift(@threadlist2,"$stickylist[$i]\n"); }
	}
	
	$counter = 0;
	$tmpa = '';
	if($counter < $start && ($buffer = $threadlist2[$counter])) {
		$tmpa = $buffer;
		$counter++;
	}
	while($counter < $start && ($buffer = $threadlist2[$counter])) { $counter++; }
	$#threads = $maxindex - 1;
	$curln = $counter;
	$counter = 0;
	while( $counter < $maxindex && ( $buffer = $threadlist2[$curln+$counter] ) ) {
		chomp $buffer;
		$threads[$counter] = $buffer;
		$counter++;
	}
	$#threads = $counter - 1;
	$curln = 0;

	# Build a list of the board's moderators.
	if( scalar keys %moderators > 0 ) {
		if( scalar keys %moderators == 1 ) { $showmods = qq~($txt{'298'}: ~; }
		else { $showmods = qq~($txt{'299'}: ~; }
		while( $_ = each(%moderators) ) {
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}" class="nav">$moderators{$_}</a>, ~;
		}
		$showmods =~ s/, \Z/)/;
	}

	# Load censor list.
	fopen(FILE,"$vardir/censor.txt");
	while( chomp( $buffer = <FILE> ) ) {
		($tmpa,$tmpb) = split(/=/,$buffer);
		push(@censored,[$tmpa,$tmpb]);
	}
	fclose(FILE);

	# Print the header and board info.
$dispprev .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
 <tr>
  <td>
   <table cellpadding="4" cellspacing="1" border="0" width="100%">
    <tr>
     <td class="titlebg" bgcolor="$color{'titlebg'}" width="10%" colspan="2"><font size="2">&nbsp;</font></td>
     <td class="titlebg" bgcolor="$color{'titlebg'}" width="44%"><font size="2" class="text1" color="$color{'titletext'}"><b>$previewtxt{'28'}</b></font></td>
     <td class="titlebg" bgcolor="$color{'titlebg'}" width="46%"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'111'}</b></font></td>
    </tr>
~;

	# Begin printing the message index for current board.
	$counter = $start;
	foreach( @threads ) {	
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $_ );
		# Set thread class depending on locked status and number of replies.
		$threadclass = 'thread';
		if( $mstate == 1 ) { $threadclass = 'locked'; $threadimgtitle = $txt{'456'}; }
		elsif( $mreplies > 24 ) { $threadclass = 'veryhotthread'; $threadimgtitle = $txt{'455'}; }
		elsif( $mreplies > 14 ) { $threadclass = 'hotthread'; $threadimgtitle = $txt{'454'}; }
		elsif( $mstate == 0 ) { $threadclass = 'thread'; $threadimgtitle = $txt{'457'}; }
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				if($threadclass eq 'locked') { $threadclass = 'stickylock'; $threadimgtitle = $txt{'780'}; }
				else { $threadclass = 'sticky'; $threadimgtitle = $txt{'779'}; }
			}
		}

		# Decide if thread should have the "NEW" indicator next to it.
		# Do this by reading the user's log for last read time on thread,
		# and compare to the last post time on the thread.
		$dlp = &getlog($mnum);
		## LAST READ MOD ##
		$stuff = &getlog($mnum);
		($dlp, $lastread) = split( /\|/, $stuff );
		if ($lastread ne '') { $lastread = qq~;start=$lastread#$lastread~;}
		## /LAST READ MOD ##
		$threaddate = stringtotime($mdate);
		if( $max_log_days_old && $dlp < $threaddate && $username ne 'Guest' && &getlog("$curboard--mark") < $threaddate ) {
		if ($txt{'302a'}) { $prenew = qq~<a href="$scripturl?board=$curboard;action=display;num=$mnum$lastread"><img src="$imagesdir/new.gif" align="middle" border="0" alt="$txt{'302a'}" /></a>~; } else { $prenew = qq~<img src="$imagesdir/new.gif" align="middle" border="0" alt="$txt{'302'}" />~; }
		}
		else { $prenew = ''; }

		# Load the current nickname of the account name of the thread starter.
		$micon = qq~<img src="$imagesdir/$micon.gif" alt="" border="0" align="middle" />~;
		$mpoll = "";
		if (-e "$datadir/$mnum.poll") {
			$mpoll = qq~<b>$polltxt{'15'}: </b>~;
			fopen (FILE, "$datadir/$mnum.poll");
			$poll_question = <FILE>; 
			fclose (FILE);
			chomp $poll_question;
			($dummy, $poll_locked, $dummy) = split(/\|/, $poll_question, 3);
			$micon = qq~$img{'pollicon'}~;
			if ($poll_locked) { $micon = $img{'polliconclosed'}; }
			else {
				fopen(FILE, "$datadir/$mnum.polled");
				$polled = <FILE>;
				fclose(FILE);
				$dlp = &getlog($mnum);
				($dummy, $dummy, $dummy, $vote_date, $dummy) = split(/\|/, $polled);
				$vote_date = stringtotime($vote_date);
				if( $max_log_days_old && $dlp < $vote_date && $username ne 'Guest' && &getlog("$curboard--mark") < $vote_date ) {$micon = qq~$img{'polliconnew'}~;}
			}
		}
		
		if( $musername ne 'Guest' && -e "$memberdir/$musername.dat" ) {
			&LoadUser($musername);
			$mname = $userprofile{$musername}->[1] || $mname || $txt{'470'};
			$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$mname</a>~;
		}
		else {
			$mname ||= $txt{'470'};
		}

		# Censor the subject of the thread.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}

		# Decide how many pages the thread should have.
		$threadlength = $mreplies + 1;
		$pages = '';
		if( $threadlength > $maxmessagedisplay ) {
			$tmpa = 1;
			for( $tmpb = 0; $tmpb < $threadlength; $tmpb += $maxmessagedisplay ) {
				$pages .= qq~<a href="$scripturl?board=$curboard;action=display;num=$mnum;start=$tmpb#$tmpb">$tmpa</a> ~;
				++$tmpa;
			}
			#$pages =~ s/\n\Z//;
			$pages = qq~<font size="1">$txt{'139'}: $pages <a href="$scripturl?board=$curboard;action=display;num=$mnum;start=0;showall=true" style="letter-spacing:1px;">$txt{'190'}</a></font>~;
		}

		if( fopen(FILE, "$datadir/$mnum.data") ) {
			$tmpa = <FILE>;
			fclose(FILE);
		}
		elsif( -e "$datadir/$mnum.data" ) {
			&fatal_error("301 $txt{'106'}: $txt{'23'} $mnum.data");
		}
		else {
			$tmpa = '0';
		}

		($views, $lastposter) = split(/\|/, $tmpa);
		if( $lastposter =~ m~\AGuest-(.*)~ ) {
			$lastposter = $1;
		}
		else {
			unless( $lastposter eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			&LoadUser($lastposterid);
		}
		$lastpostername = $lastposter || $txt{'470'};
		$views = $views ? $views - 1 : 0;
		
		# Attachment Threads
		fopen(FILE, "$vardir/attachments.txt");
		@attached = <FILE>;
		fclose(FILE);

		# Has Image Indicator
		fopen(FILE, "$datadir/$mnum.txt");
		@starter = <FILE>;
		fclose(FILE);
		$has_img = '';
		$has_attach = '';
		if (@attached) {
		foreach $alx (@starter) {
			if($alx =~ /img\]/i) {$has_img = qq~&nbsp;<img src="$imagesdir/has_img.gif" alt="" align="bottom" />~;}
		}
		foreach $alx (@attached) {
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$alx);
			if($mnum eq $amthreadid) { 
				if(($amfn =~ /(jpg|gif|bmp|png|jpeg)$/i) && ($amdisplaypics == 1)) { 
					$has_img = qq~&nbsp;<img src="$imagesdir/has_img.gif" alt="" align="bottom" />~; 
				} else {  
					$has_attach = qq~&nbsp;<img src="$imagesdir/paperclip.gif" alt="" align="bottom" />~; 
				} 
			}
		} 
		}		 
		
		# Print the thread info.
		$mydate = &timeformat($mdate);
		$dispprev .= qq~
      <tr>
       <td class="windowbg2" valign="middle" align="center" width="6%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$threadclass.gif" alt="$threadimgtitle" /></td>
       <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}">$micon</td>
       <td class="windowbg" valign="middle" width="44%" bgcolor="$color{'windowbg'}"><table border="0" width="100%" cellspacing="0" cellpadding="0"><tr><td>$prenew <font size="2">$mpoll<a href="$scripturl?board=$curboard;action=display;num=$mnum"><b>$msub</b></a></font>$has_img$has_attach</td><td valign="top"></td></tr><tr><td colspan="2"><font size="2">$pages</font></td></tr></table></td>
       <td class="windowbg2" valign="middle" width="46%" bgcolor="$color{'windowbg2'}"><font size="1">$mydate<br />$txt{'525'} $lastpostername</font></td>
      </tr>
      ~;
		++$counter;
	}
	
	# Mark current board as seen if there are nothing new.
	if ($prenew eq '') { &dumplog($curboard); }
	
	$dispprev .= qq~
    </table>
    </td>
  </tr>
</table>
~;
}
	
sub PreviewPost { # this is ripped off from Display.pl and Subs.pl, then stripped and modified
	$dispprev = "";
	local($viewnum,$currentboard,$prereplies,$browser,$viewpages,$mstate) = @_;
	if( $viewnum =~ /\D/ ) { &fatal_error($txt{'337'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); } 
	
	if ($usepreviewstyle == 0) {
	# View the number of views of this thread.
	if(fopen(FILE, "$datadir/$viewnum.data")) {
		$tmpa = <FILE>;
		fclose(FILE);
	}
	$views = $tmpa - 1;
	}

	# Look for a poll file for this thread.
	if (-e "$datadir/$viewnum.poll") { $has_poll = 1; } else { $has_poll = 0; }

 	# Get the class of this thread, based on lock status and number of replies.
 	$replybutton = qq~<a href="$cgi;action=post;num=$viewnum;title=$txt{'116'}">$img{'reply'}</a>~;

	if ($has_poll || $useraddpoll == 0) { $pollbutton = ""; }
	
	&LoadCensorList;	# Load Censor List
	
	if($enable_notification) {
		my $startnum = $start || '0';
		$notify = qq~$menusep<a href="$cgi;action=notify;thread=$viewnum;start=$startnum">$img{'notify'}</a>~;
	}
	
	# check if number of viewing replies is less than total or 0 or Mozilla/NS is used, then print preview title
	$preall = $prereplies; # have not yet removed the unneccesary use of $preall var.
	&TPB_PPB_Crossbrowser;
	 	
	if ($prereplies <= $numberpreviewreplies && $prereplies == 1) { $viewrepliestitle = qq~<font size="1"><a href="$cgi;action=display;num=$viewnum;start=">$prereplies $previewtxt{'23'}</a></font>~; }
 	elsif ($prereplies <= $numberpreviewreplies && $prereplies != 0) { $viewrepliestitle = qq~<font size="1"><a href="$cgi;action=display;num=$viewnum;start=">$prereplies $previewtxt{'3'}</a></font>~; }
  elsif ($prereplies == 0) { $viewrepliestitle = qq~<font size="1"><a href="$cgi;action=display;num=$viewnum;start=">$previewtxt{'7'}</a></font>~; }
  elsif ($prereplies == 1 && $numberpreviewreplies != 0) { $viewrepliestitle = qq~<font size="1"><a href="$cgi;action=display;num=$viewnum;start=">$prereplies $previewtxt{'23'}</a>$menusep<a href="$cgi;action=display;num=$viewnum;start=$preall\#$preall">$previewtxt{'6'}</a></font>~; }
  else { $viewrepliestitle = qq~<font size="1"><a href="$cgi;action=display;num=$viewnum;start=">$prereplies $previewtxt{'3'}</a>$menusep<a href="$cgi;action=display;num=$viewnum;start=$preall\#$preall">$previewtxt{'6'}</a></font>~; }
	
  if ($browser =~ /Mozilla\/5\.0/ && $prereplies != 0 && $prereplies != 1) { $numberpreviewreplies = 0; $viewrepliestitle = qq~<font size="1"><a href="$cgi;action=display;num=$viewnum;start=">$prereplies $previewtxt{'3'}</a>$menusep<a href="$cgi;action=display;num=$viewnum;start=$preall\#$preall">$previewtxt{'6'}</a></font>~; }
	elsif ($browser =~ /Mozilla\/5\.0/ && $prereplies == 1) { $numberpreviewreplies = 0; $viewrepliestitle = qq~<font size="1"><a href="$cgi;action=display;num=$viewnum;start=">$prereplies $previewtxt{'23'}</a>$menusep<a href="$cgi;action=display;num=$viewnum;start=$preall\#$preall">$previewtxt{'6'}</a></font>~; }
	
	# Begin output depending of previewstyle
 	if ($usepreviewstyle == 1) { &PreviewTitle; } else {
	$dispprev .= qq~
	<table border="0" width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor"> 
   <tr> 
    <td>
     <table cellpadding="4" cellspacing="1" border="0" width="100%"> 
      <tr> 
       <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
       	<table cellpadding="3" cellspacing="0" width="100%">
      	 <tr> 
       		<td><font size="2">$viewrepliestitle</font></td> 
       		<td class="catbg" bgcolor="$color{'catbg'}" align="right"><font size="2"> $replybutton$pollbutton$notify$menusep<a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep<a href="$cgi;action=print;num=$viewnum" target="_blank">$img{'print'}</a> </font></td>
      	 </tr> 
		 		</table>
    	 </td>
   		</tr> 
  	 </table>
   	</td>
   </tr> 
 	</table>
~;
}
	
	if ($usepreviewstyle == 0) {
			$dispprev .= qq~
~;
	if ($has_poll) { &display_poll_preview($viewnum); }
	$dispprev .= qq~
<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center"> 
 <tr> 
  <td>
   <table cellpadding="3" cellspacing="1" border="0" width="100%"> 
    <tr> 
     <td valign="middle" align="left" width="20%" bgcolor="$color{'titlebg'}" class="titlebg"> <font size="2" class="text1" color="$color{'titletext'}">&nbsp;<img src="$imagesdir/$threadclass.gif" alt="$threadimgtitle" />&nbsp;<b>$txt{'29'}</b></font></td> 
     <td valign="middle" align="left" bgcolor="$color{'titlebg'}" class="titlebg" width="80%"><font size="2" class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})</font></td> 
    </tr> 
   </table>
  </td> 
 </tr> 
</table>~;
}

	# Load background color list.
	@bgcolors = ( $color{windowbg}, $color{windowbg2} );
	$bgcolornum = scalar @bgcolors;
	@cssvalues = ( "windowbg","windowbg2" );
	$cssnum = scalar @bgcolors;

	if(!$MenuType) { $sm = 1; }
	$counter = 0;

	fopen(FILE,"$datadir/$viewnum.txt") || &fatal_error("104 $txt{'106'}: $txt{'23'} $viewnum.txt");

	# Skip past the posts in this thread until we reach $start.
	while($counter < $start && ($buffer = <FILE>)) { $counter++; }

	$#messages = $numberpreviewreplies;
	for($counter = 0; $counter < $numberpreviewreplies + 1 && ($buffer = <FILE>); $counter++) {
		$messages[$counter] = $buffer;
	}
	fclose(FILE);
	$#messages = $counter - 1;
	$counter = $start;

	# For each post in this thread:
	foreach (@messages) {
		undef $realgroup;
		$windowbg = $bgcolors[($counter % $bgcolornum)];
		$css = $cssvalues[($counter % $cssnum)];
		chomp;
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $_);
		# Should we show "last modified by?"
		if( $mlm && $showmodify && $mlm ne "" && $mlmb ne "") {
			$mlm = &timeformat($mlm);
			&LoadUser($mlmb);
			$mlmb = $userprofile{$mlmb}->[1] || $mlmb || $txt{'470'};
			$lastmodified = qq~&laquo; <i>$txt{'211'}: $mlm $txt{'525'} $mlmb</i> &raquo;~;
		}
		else {
			$mlm = '-';
			$lastmodified = '';
		}
		$msub ||= $txt{'24'};
		$messdate = &timeformat($mdate);
		if ($settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' && $allow_mod == 1) { $mip = $mip } else { $mip = "$txt{'511'}"; }
		$sendm = '';

		# If the user isn't a guest, load his/her info.
		if($musername ne 'Guest' && ! $yyUDLoaded{$musername} && -e("$memberdir/$musername.dat") ) {
			&LoadUserDisplay($musername);	# If user is not in memory, s/he must be loaded.
		}
		if($yyUDLoaded{$musername}) {
			@userprofile = @{$userprofile{$musername}};
			$displayname = $userprofile[1];
			$star = $memberstar{$musername};
			$memberinfo = $memberinfo{$musername};
			$memberinfo =~ s~\n~~g;
			$icqad = $icqad{$musername};
			$yimon = $yimon{$musername};
			if($username ne 'Guest') {
				# Allow instant message sending if current user is a member.
				$sendm = qq~$menusep<a href="$cgi;action=imsend;to=$useraccount{$musername}">$img{'message_sm'}</a>~;
			}
			$usernamelink = qq~<a href="$cgi;action=viewprofile;username=$useraccount{$musername}"><font size="2"><b>$userprofile[1]</b></font></a>~;
			$postinfo = qq~$txt{'26'}: $userprofile[6]<br />~;
			$memail = $userprofile[2];
		}
		else {
			$musername = "Guest";
			$star = '';
			$memberinfo = "$txt{'28'}";
			$icqad = '';
			$yimon = '';
			$usernamelink = qq~<font size="2"><b>$mname</b></font>~;
			$postinfo = '';
			@userprofile = ();
			$displayname = $mname;
		}
		# Censor the subject and message.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		
		# Snip large messages cause of the preview
		$sniptext = qq~...<br /><br />$previewtxt{'20'}~;
		if (length($postmessage) > $previewsnip) { $postmessage = substr($postmessage, 0, $previewsnip) . $sniptext; }
		$message = $postmessage;
		
		# Run UBBC interpreter on the message.
		$glowbg = $windowbg;
		$message = $postmessage; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
		# Next 2 lines links image and flash instead of viewving cause of the preview
		$message =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~<a href="http\:\/\/$2" alt="" target="new"><img src="$imagesdir/img.gif" alt="" style="border\:0" /></a>~isg;
		$message =~ s~\[flash\=(\S+?),(\S+?)](\S+?)\[\/flash\]~<a href="$3" alt="" target="new"><img src="$imagesdir/flash.gif" alt="" style="border\:0" /></a>~g;
		&DoUBBC; }
		&wrap2;
		$profbutton = $profilebutton && $musername ne 'Guest' ? qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$img{'viewprofile_sm'}</a>$menusep~ : '';
		if($counter != 0) { $counterwords = qq~$txt{'146'} #$counter~; }
		else { $counterwords = ""; }
		# Print the post and user info for the poster.
		if ($usepreviewstyle == 1) {
		$dispprev .= qq~
		<table width="100%" border="0" align="center" cellpadding="4" cellspacing="0" bgcolor="$windowbg" class="$css"> 
 		 <tr> 
		  <td align="left" nowrap><font size="2"><a name="$counter"></a><img src="$imagesdir/$threadclass.gif" alt="$threadimgtitle" />&nbsp;<font size="1"><b>$txt{'29'}</b>: $usernamelink </font></td> 
    	<td align="left" class="$css"><font size="1">$messdate</font></td> 
    	<td height="20" align="right" nowrap class="$css"><font size=-1>~; if ($mstate != 1) { $dispprev .= qq~<a href="$cgi;action=post;num=$viewnum;quote=$counter;title=$txt{'116'};start=$start">$img{'replyquote'}</a>$menusep<a href="$cgi;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>~; if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername || $settings[7] eq 'Global Moderator') { $dispprev .= qq~ $menusep<a href="$cgi;action=modify2;thread=$viewnum;id=$counter;d=1" onclick="return confirm('$txt{'739'}')">$img{'delete'}</a>~; } } $dispprev .= qq~</font></td>
  	 </tr> 
  	 <tr> 
      <td height="50%" colspan="3" valign="top" bgcolor="$windowbg" class="$css"><hr width="100%" size="1" class="hr"/><font size="2">$message</font><hr width="100%" size="1" class="hr"/></td> 
  		</tr> 
		</table>
		~;
		} else { 
		$dispprev .= qq~
		<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  	 <tr>
      <td>
    	 <table cellpadding="3" cellspacing="1" border="0" width="100%">
    	  <tr>
    	   <td bgcolor="$windowbg" class="$css"><a name="$counter"></a>
    	   	<table width="100%" cellpadding="4" cellspacing="0" class="$css" bgcolor="$windowbg">
    			 <tr>
    			 	<td class="$css" bgcolor="$windowbg" valign="top" width="20%" rowspan="2">
    			 	 <font size="1">$usernamelink
    $memberinfo<br />~;
	if($musername ne "Guest") {
		$dispprev .= qq~
            $star<br /><br />
            $userprofile[13]$userprofile[12]
            <br />$userprofile[8] $icqad &nbsp; $userprofile[10] $yimon &nbsp; $userprofile[9]<br />
~;
	}
	if($musername eq "Guest") {
		$dispprev .= qq~
            <br /><a href="mailto:$memail">$img{'email_sm'}</a><br /><br />
~;
	}
	elsif ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $allow_hide_email ne 1) {
		$dispprev .= qq~
            $profbutton$userprofile[4] <a href="mailto:$memail">$img{'email_sm'}</a>$sendm<br /><br />
~;
	} else {
		$dispprev .= qq~
    $profbutton$userprofile[4]$sendm<br /><br />
~;
	}
	$dispprev .= qq~
            $userprofile[11]
            $postinfo
          </font>
         </td>
         <td class="$css" bgcolor="$windowbg" valign="top" width="80%" height="100%">
          <table width="100%" border="0">
           <tr>
            <td align="left" valign="middle"><font size="2"><b>$msub</b></font><br /><font size="1">&laquo; <b>$counterwords $txt{'30'}:</b> $messdate &raquo;</font></td>
            <td align="right" valign="bottom" nowrap height="20">
            <font size=-1>
                ~;
if ($mstate != 1)
{
$dispprev .= qq~<a href="$cgi;action=post;num=$viewnum;quote=$counter;title=$txt{'116'};start=$start">$img{'replyquote'}</a>$menusep<a href="$cgi;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername || $settings[7] eq 'Global Moderator') {
		$dispprev .= qq~ $menusep<a href="$cgi;action=modify2;thread=$viewnum;id=$counter;d=1" onclick="return confirm('$txt{'739'}')">$img{'delete'}</a>~;
	}
}
	$dispprev .= qq~
	 		      </font>
			     </td>
			    </tr>
  	     </table>
  	  	<hr width="100%" size="1" class="hr"/><font size="2"> $message </font></td> 
	     </tr> 
	      <tr> 
         <td class="$css" bgcolor="$windowbg" valign="bottom"> <table width="100%" border="0"> 
          <tr> 
           <td align="left"><font size="1">$lastmodified</font></td> 
           <td align="right"><font size="1"><img src="$imagesdir/ip.gif" alt="" border="0" /> $mip</font></td> 
          </tr> 
         </table> 
        <font size="1"> $userprofile[5] </font></td> 
       </tr> 
      </table> 
     </td> 
    </tr> 
   </table> 
  </td> 
 </tr> 
</table> 

~;
}
		$counter++;
	}
	if ($numberpreviewreplies != 0) { 
	$dispprev .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
 <tr>
  <td>
   <table cellpadding="4" cellspacing="1" border="0" width="100%">
    <tr>
     <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
      <table cellpadding="3" cellspacing="0" width="100%">
       <tr>
        <td><font size="2">$viewrepliestitle</font></td>
        <td class="catbg" bgcolor="$color{'catbg'}" align=right>
         <font size="2">
         $replybutton$pollbutton$notify$menusep
         <a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
         <a href="$cgi;action=print;num=$viewnum" target="_blank">$img{'print'}</a>
         </font>
        </td>
       </tr>
      </table>
     </td>
    </tr>
   </table>
  </td>
 </tr>
</table>
~;
}

}

sub PreviewTitle {
if ($has_poll) { &display_poll_preview($viewnum); }
$dispprev .= qq~
<table border="0" width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor"> 
 <tr> 
  <td>
   <table cellpadding="2" cellspacing="1" border="0" width="100%"> 
    <tr> 
     <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
      <table cellpadding="3" cellspacing="0" width="100%"> 
       <tr> 
        <td><font size="2">$viewrepliestitle</font></td> 
        <td class="catbg" bgcolor="$color{'catbg'}" align="right"><font size="2"> $replybutton$pollbutton$notify$menusep<a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep<a href="$cgi;action=print;num=$viewnum" target="_blank">$img{'print'}</a> </font></td> 
       </tr> 
      </table>
     </td> 
    </tr> 
   </table>
  </td> 
 </tr> 
</table>
~;
}

sub display_poll_preview {
	$pollnum = @_[0];

	&LoadCensorList;	# Load Censor List

	fopen (FILE, "$datadir/$pollnum.poll");
	$poll_question = <FILE>;
	@poll_data = <FILE>;
	fclose (FILE);
	chomp $poll_question;
	($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_vote, $poll_mod, $poll_modname, $poll_comment) = split(/\|/, $poll_question);

	$has_voted = 0;
	if (!$guest_vote && $username eq "Guest") { $has_voted = 4; }
	else {
		fopen(FILE, "$datadir/$pollnum.polled");
		@polled = <FILE>;
		fclose(FILE);
		foreach $tmpLine (@polled){
			chomp $tmpline;
			($voters_ip, $voters_name, $voters_vote, $vote_date) = split(/\|/, $tmpLine);
			   if ($username eq "Guest" && $voters_name eq "Guest" && lc $voters_ip eq lc $user_ip) { $has_voted = 1; last; }
			elsif ($username eq "Guest" && $voters_name ne "Guest" && lc $voters_ip eq lc $user_ip) { $has_voted = 2; last; }
			elsif ($username ne "Guest" && lc $username eq lc $voters_name) { $has_voted = 3; last; }
		}
	}

	my @options;
	my @votes;
	my $totalvotes = 0; 
	my $maxvote = 0;
	for(my $i = 0; $i < @poll_data; $i++) {
		chomp $poll_data[$i];
		($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
		$totalvotes += int($votes[$i]); 
		if (int($votes[$i]) >= $maxvote) { $maxvote = int($votes[$i]); }
	} 

	$endedtext = "";
	if ($username ne "Guest" && ($username eq $poll_uname || $settings[7] eq "Administrator" || $settings[7] eq "Global Moderator" || exists $moderators{$username})) {
		if ($poll_locked) {
			$lockpoll = qq~<a href="$cgi;action=lockpoll;num=$pollnum" class="altlink">$img{'openpoll'}</a>~;
		} else {
			$lockpoll = qq~<a href="$cgi;action=lockpoll;num=$pollnum" class="altlink">$img{'closepoll'}</a>~;
		}
		$modifypoll = qq~$menusep<a href="$cgi;action=modify;message=$polltxt{'15'};thread=$pollnum" class="altlink">$img{'modifypoll'}</a>~;
		$deletepoll = qq~$menusep<a href="$cgi;action=modify2;thread=$pollnum;id=$polltxt{'15'};d=1" onclick="return confirm('$polltxt{'44'}')" class="altlink">$img{'deletepoll'}</a>~;
		if ($settings[7] eq "Administrator") { $displayvoters = qq~<a href="$cgi;action=showvoters;num=$pollnum">$img{'viewvotes'}</a>~;}
		if ($hide_results) {
			$endedtext = qq~<tr>
                  <td colspan="2" align="center"><font size="2"><b>$polltxt{'53'}</b></font><br /><br /></td>
                </tr>~;
			$hide_results = 0;
		}
	}

	if($poll_modname ne "" && $poll_mod ne "" && $showmodify) {
		$poll_mod = &timeformat($poll_mod);
		fopen (FILE, "$memberdir/$poll_modname.dat");
		@info = <FILE>;
		fclose(FILE);
		chomp $info[1];
		$displaydate = qq~<font size="1">&laquo; $polltxt{'45a'}: <a href="$cgi;action=viewprofile;username=$poll_modname">$info[1]</a> $polltxt{'46'}: $poll_mod &raquo;</font>~;
	} elsif ($poll_uname ne "" && $poll_date ne "") {
		$poll_date = &timeformat($poll_date);
		if($poll_uname ne 'Guest' && -e "$memberdir/$poll_uname.dat") {
			fopen (FILE, "$memberdir/$poll_uname.dat");
			@info = <FILE>;
			fclose(FILE);
			chomp $info[1];
			$displaydate = qq~<font size="1">&laquo; $polltxt{'45'}: <a href="$cgi;action=viewprofile;username=$poll_uname">$info[1]</a> $polltxt{'46'}: $poll_date &raquo;</font>~;
		} elsif ($poll_name ne "") {
			$displaydate = qq~<font size="1">&laquo; $polltxt{'45'}: $poll_name $polltxt{'46'}: $poll_date &raquo;</font>~;
		} else {
			$displaydate = "";
		}
	} else {
		$displaydate = "";
	}

	if ($poll_locked) {
		$endedtext = qq~<tr>
                  <td colspan="2" align="center"><font size="2"><b>$polltxt{'22'}</b></font><br /><br /></td>
                </tr>~;
		$poll_icon = qq~$img{'polliconclosed'}~;
		$has_voted = 5;
	} else {
		$poll_icon = qq~$img{'pollicon'}~;
	}

	# Censor the question.
	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$poll_question =~ s~\Q$tmpa\E~$tmpb~gi;
		$poll_comment =~ s~\Q$tmpa\E~$tmpb~gi;
	}
	if($ubbcpolls) { 
		if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
		$message = $poll_question;
		&DoUBBC;
		$poll_question = $message;
	}

	$deletevote = "";
	if ($has_voted) {
		$footer = qq~$polltxt{'17'}: $totalvotes~;
		$width = qq~~;
		$deletevote = qq~<a href="$cgi;action=undovote;num=$pollnum">$img{'deletevote'}</a>~;
		if ($settings[7] eq "Administrator") { $deletevote = $deletevote.$menusep; }
	} else {
		$footer = qq~<input type="submit" value="$polltxt{'18'}" />~;
		$width = qq~ width="80%"~;
	}
	if ($username eq "Guest") { $deletevote = ""; }
	if ($poll_locked) { $deletevote = ""; }

	$dispprev .= qq~
<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
      <table cellpadding="3" cellspacing="1" border="0" width="100%">
        <tr>
          <td align="left" class="titlebg" bgcolor="$color{'titlebg'}" width="100%">
            <table cellpadding="0" cellspacing="0" width="100%">
              <tr>
                <td valign="middle" align="left"><font size="2" class="text1" color="$color{'titletext'}">$poll_icon <b>$polltxt{'15'}</b></font></td>
                <td valign="middle" align="right"><font size="1" color="$color{'titletext'}">$lockpoll$modifypoll$deletepoll</font></td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <td valign="top" align="center" bgcolor="$color{'windowbg2'}" class="windowbg2">
            <form name="poll" method="post" action="$cgi;action=vote;num=$pollnum" style="display:inline">
              <table border="0" width="100%" cellspacing="0" cellpadding="0">
                <tr>
                  <td colspan="2"><font size="2"><b>$polltxt{'16'}:</b> $poll_question</font><br /><br /></td>
                </tr>$endedtext<tr>
                  <td colspan="2" align="center">~;

	if ($has_voted && $hide_results && !$poll_locked) {

		# Display Poll Hidden Message
		$dispprev .= qq~<font size="2">$polltxt{'47'}</font><br /><font size="1">($polltxt{'48'})</font><br />~;

	} else {

		$dispprev .= qq~
                     <table$width border="0" cellspacing="2" cellpadding="0">~;

		for($i = 0; $i < @options; $i++) {

			unless ($options[$i]) {next;};

			# Censor the options.
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$options[$i] =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			$options[$i] =~ s~[\n\r]~~g;

			if($ubbcpolls) {
				if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
				$message = $options[$i];
				&DoUBBC;
				$options[$i] = $message;
			}

			if ($has_voted) {

				# Display Poll Results

				$pollpercent = 0;
				$pollbar = 0;
				if ($totalvotes ne 0 && $maxvote ne 0) {
					$pollpercent = int(1000 * $votes[$i] / $totalvotes);
					$pollpercent = $pollpercent / 10;
					$pollbar = int( 150 * $votes[$i] / $maxvote);
				}

				$dispprev .= qq~
                      <tr>
                        <td valign="middle"><font size="2"><b>$options[$i]&nbsp;&nbsp;</b></font></td>
                        <td valign="middle" width="250"><font size="2">&nbsp;<img src="$imagesdir/poll_left.gif" align="absmiddle" alt="" /><img src="$imagesdir/poll_middle.gif" height="12" width="$pollbar" align="absmiddle" alt="" /><img src="$imagesdir/poll_right.gif" align="absmiddle" alt="" /> $votes[$i] ($pollpercent%)</font></td>
                      </tr>~;

			} else {

				# Display Poll Options
				if ($multi_vote) { $input = qq~<input type="checkbox" name="option$i" value="$i" />~; } else { $input = qq~<input type="radio" name="option" value="$i" />~; }

				$dispprev .= qq~
                      <tr>
                        <td valign="middle" width="25">$input</td>
                        <td valign="middle"><font size="2"><b>$options[$i]</b></font></td>
                      </tr>~;

			}
		} 
		$dispprev .= qq~
                    </table>~;
	} 

	$dispprev .= qq~
                  </td>
                </tr><tr>
                  <td colspan="2" align="center"><br /><font size="2"><b>$footer</b></font></td>
                </tr><tr>~;
		if ($poll_comment ne "") {
			$message = $poll_comment;
			if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
			$poll_comment = $message;
			$dispprev .= qq~
                  <td colspan="2"><br /><font size="2">$poll_comment</font></td>
                </tr><tr>~;}
		$dispprev .= qq~
                  <td valign="bottom"><br /><font size="1">$displaydate</font></td>
                  <td valign="bottom" align="right"><br /><font size="1">$deletevote$displayvoters</font></td>
                </tr>
              </table>
            </form>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>~;

}

sub PreviewSettings {	
	&is_admin;	
	if(fopen(FILE, "$vardir/previewsettings.txt")) {
	@previewsettingslist = <FILE>;
	fclose(FILE);
	}
	else { &PreviewSettings2; }
	
	$i = 0;
	foreach $previewsettingsitem(@previewsettingslist){
		$i++;
		chomp($previewsettingsitem);
		($tpbusers,$tpbguests,$numberpreviewsubjects,$descwidth,$descleft,$ppbusers,$ppbguests,$numberofpostpreviews,$numberpreviewreplies,$usepreviewstyle,$previewwidth,$previewheight,$previewleft,$previewsnip,$boarddescposition) = split(/\|/,$previewsettingsitem);
	}

	if ($tpbusers) { $tpbuserschecked = qq~"checked"~; $checked1 = qq~checked=~; }
	if ($tpbguests) { $tpbguestschecked = qq~"checked"~; $checked2 = qq~checked=~; }
	if ($ppbusers) { $ppbuserschecked = "checked"; $checked3 = qq~checked=~; }
	if ($ppbguests) { $ppbguestschecked = "checked"; $checked4 = qq~checked=~; }
	if ($usepreviewstyle) { $usepreviewstylechecked = "checked"; $checked5 = qq~checked=~; }
	if (!$numberpreviewsubjects) { $numberpreviewsubjects = "5"; }
	if (!$descwidth) { $descwidth = "600"; }	
	if (!$descleft) { $descleft = "200"; }
	if (!$numberofpostpreviews) { $numberofpostpreviews = "5"; }
	if (!$numberpreviewreplies) { $numberpreviewreplies = "0"; }
	if (!$previewwidth) { $previewwidth = "650"; }
	if (!$previewheight) { $previewheight = "300"; }
	if (!$previewleft) { $previewleft = "250"; }
	if (!$previewsnip) { $previewsnip = "400"; }
	# Extra setting, not anything to do with TPB-PPB but it is included instead of a standalone mod since it is so small anyways
	if ($boarddescposition == 1) { $bdpsl1 = qq~selected="selected"~; } elsif ($boarddescposition == 2) { $bdpsl2 = qq~selected="selected"~; }

	$yymain .= qq~
<form action="$cgi&amp;action=previewsettings2" method="POST">
<table border="0" width="60%" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center"><tr><td>
<table border="0" width="100%" cellspacing="0" cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><img src="$imagesdir/xx.gif" alt="" /><font size="2" class="text1" color="$color{'titletext'}"><b>$previewtxt{'29'}</b></font></td>
  </tr><tr>
    <td colspan="2" class="windowbg" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'19'}</font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'16'} - $previewtxt{'32'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="tpbusers" $checked1$tpbuserschecked /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'16'} - $previewtxt{'33'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="tpbguests" $checked2$tpbguestschecked /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'27'} $previewtxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="numberpreviewsubjects" size="5" value="$numberpreviewsubjects" /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'17'}$previewtxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="descwidth" size="5" value="$descwidth" /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'18'} $previewtxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="descleft" size="5" value="$descleft" /></td>
  </tr><tr>
    <td colspan="2" class="windowbg" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'14'}</font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'8'} - $previewtxt{'32'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="ppbusers" $checked3$ppbuserschecked /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'8'} - $previewtxt{'33'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="ppbguests" $checked4$ppbguestschecked /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'22'} $previewtxt{'13'}</font><br /><font size="1">$previewtxt{'25'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="numberofpostpreviews" size="5" value="$numberofpostpreviews" /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'5'} $previewtxt{'9'}</font><br /><font size="1">$previewtxt{'24'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="numberpreviewreplies" id="numbprev" onblur="if(document.getElementById('numbprev').value=='0'){ document.getElementById('prevheight').value='auto' } else if (document.getElementById('numbprev').value!='0' && document.getElementById('prevheight').value=='auto') { document.getElementById('prevheight').value='147' }" size="5" value="$numberpreviewreplies" /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'10'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="usepreviewstyle" $checked5$usepreviewstylechecked /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'11'} $previewtxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="previewwidth" size="5" value="$previewwidth" /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'12'} $previewtxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="previewheight" id="prevheight" onblur="if(document.getElementById('numbprev').value=='0'){ document.getElementById('prevheight').value='auto' }" size="5" value="$previewheight" /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'15'} $previewtxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="previewleft" size="5" value="$previewleft" /></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'21'} $previewtxt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="previewsnip" size="5" value="$previewsnip" /></td>
  </tr><tr> 
    <td colspan="2" class="windowbg" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'30'}</font></td>
  </tr><tr>
  	<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$previewtxt{'4'}</font><br /><font size="1">$previewtxt{'31'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="boarddescpos" size="1">
    <option value="1" $bdpsl1>$previewtxt{'1'}</option>
    <option value="2" $bdpsl2>$previewtxt{'2'}</option>
    </select>
    </td>
  </tr><tr>
  	<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center" colspan="2"><br /><input type="submit" value="$txt{'10'}" /></td>
  </tr>
	</table>
</td></tr></table>
</form>
~;

	$yytitle = $previewtxt{'29'};
	&template;
	exit;
}

sub PreviewSettings2 {
	&is_admin;
	
	push(@onoff,  "tpbusers", "tpbguests", "ppbusers", "ppbguests", "usepreviewstyle");
	# Set as 0 or 1 if box was checked or not
	my $fi;
	map { $fi = lc $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;

# Print the settings to file
fopen(FILE, ">$vardir/previewsettings.txt",1);
	$numberpreviewsubjects = $FORM{'numberpreviewsubjects'} || 5;
	$numberpreviewsubjects =~ s/\D//g;
	$descwidth = $FORM{'descwidth'} || 600;
	$descwidth =~ s/\D//g;
	$descleft = $FORM{'descleft'} || 200;
	$descleft =~ s/\D//g;
	$numberofpostpreviews = $FORM{'numberofpostpreviews'} || 5;
	$numberofpostpreviews =~ s/\D//g;	
	$numberpreviewreplies = $FORM{'numberpreviewreplies'} || 0;
	if ($numberpreviewreplies == 0) { $FORM{'previewheight'} = 'auto'; }
	$numberpreviewreplies =~ s/\D//g;
	$previewwidth = $FORM{'previewwidth'} || 650;
	$previewwidth =~ s/\D//g;
	$previewheight = $FORM{'previewheight'} || 300;
	if ($previewheight !~ /auto/g) {
	$previewheight =~ s/\D//g; }
	if ($usepreviewstyle) { $previewheight = $FORM{'previewheight'} || 147; }
	$previewleft = $FORM{'previewleft'} || 250;
	$previewleft =~ s/\D//g;
	$previewsnip = $FORM{'previewsnip'} || 400;
	$previewsnip =~ s/\D//g;
	$boarddescposition = $FORM{'boarddescpos'} || 1;
	$boarddescposition =~ s/\D//g;
	
	my($previewstring) = join ("|",$tpbusers,$tpbguests,$numberpreviewsubjects,$descwidth,$descleft,$ppbusers,$ppbguests,$numberofpostpreviews,$numberpreviewreplies,$usepreviewstyle,$previewwidth,$previewheight,$previewleft,$previewsnip,$boarddescposition);
	
	print FILE qq~$previewstring~;
	
fclose(FILE);

	$yySetLocation = qq~$cgi&action=previewsettings~;
	&redirectexit;
}

sub ReadPreviewSettings {
	fopen(FILE, "$vardir/previewsettings.txt");
	@previewsettingslist = <FILE>;
	fclose(FILE);
	$i = 0;
	foreach $previewsettingsitem(@previewsettingslist){
		$i++;
		chomp($previewsettingsitem);
		($tpbusers,$tpbguests,$numberpreviewsubjects,$descwidth,$descleft,$ppbusers,$ppbguests,$numberofpostpreviews,$numberpreviewreplies,$usepreviewstyle,$previewwidth,$previewheight,$previewleft,$previewsnip,$boarddescposition) = split(/\|/,$previewsettingsitem);
	}
}

1;